define("widgets/Dialog", [
 "widgets/Overlay",
 "plugins/text!widgets/templates/Dialog.html"
], function(Overlay, template) {
    var Dialog = {
        domNode: null,
        parentNode: null,
        onSubmit: null,
        onCancel: null,
        initInstance: function(args) {
            jQuery.extend(this, args);
            var dialogTemplate = jQuery(template)
                .clone();
            this.domNode = jQuery(dialogTemplate)
                .get();
            this.parentNode.append(this.domNode);
            Overlay.initInstance({
                parentNode: this.parentNode
            });
            jQuery(dialogTemplate)
                .find(".dlg-btn-submit")
                .bind("click", jQuery.proxy(this.onSubmit, this));
            jQuery(dialogTemplate)
                .find(".dlg-btn-cancel")
                .bind("click", jQuery.proxy(this.onCancel, this));
        },
        updateInstance: function(args) {
            /* remove the overlay from the existing location and place at the new location */
            if (args.parentNode) {
                this.parentNode.remove(this.domNode);
                jQuery.extend(this, args);
                this.parentNode.add(this.domNode);
            }
            if (args.onSubmit) {
                jQuery(dialogTemplate)
                    .find(".dlg-btn-submit")
                    .bind("click", jQuery.proxy(this.onSubmit, this));
            }
            if (args.onCancel) {
                jQuery(dialogTemplate)
                    .find(".dlg-btn-cancel")
                    .bind("click", jQuery.proxy(this.onCancel, this));
            }
        },
        show: function() {
            Overlay.show();
            jQuery(this.domNode)
                .removeClass("hide")
                .addClass("show");
        },
        hide: function() {
            Overlay.hide();
            jQuery(this.domNode)
                .removeClass("show")
                .addClass("hide");
        },
        onSubmit: function() {},
        onCancel: function() {}
    };
    return Dialog;
});

