define(["plugins/text!widgets/templates/Header.html"
], function(template) {
    return function(args) {
        var Header = {
            title: null,
            domNode: null,
            controlsDisabled: false,
            sideMenuDisabled: false,
            init: function() {
                jQuery.extend(this, args);
                if (!this.title) this.title = jQuery("header")
                    .attr("data-header-title");
                var headerTemplate = jQuery(template)
                    .clone();
                jQuery(headerTemplate)
                    .find("p.navbar-title")
                    .text(this.title);
                if (this.controlsDisabled) {
                    jQuery(headerTemplate)
                        .find(".navbar-page-nav")
                        .css({
                            display: "none"
                        });
                    jQuery(headerTemplate)
                        .find(".navbar-header")
                        .addClass("navigation-disabled");
                };
                if (this.sideMenuDisabled) {
                    jQuery(headerTemplate)
                        .find(".nav-button-slideout")
                        .css({
                            display: "none"
                        })
                    jQuery(headerTemplate)
                        .find(".navbar-header")
                        .addClass("menu-disabled");
                };
                this.domNode = jQuery(headerTemplate)
                    .get();
            }
        };
        jQuery(Header.init());
        return Header;
    };
});

